////===============================================================================================
#include  "M451Series.h"
#include  "IP_Initial.h"
#include  "A_Motor.h"
#include  "M451_FOC_LIB.h"

#define  VIN_WORK_MIN_UP           (  13*10)              // ͣתʱġתѹ, 0.1Vѹֵ,Գ10
#define  VIN_WORK_MIN              (  12*10)              // תʱĵѹ, ٵ;ͣת
#define  VIN_WORK_MAX              (1600*10)              // ߹ѹ, 1638.3V ת
#define  MOTOR_POWER_MAX           (60*100)               //  60W

#define  RELAY_ON()                (PA2 = 1)              // Դ̵  
#define  RELAY_OFF()               (PA2 = 0) 

extern uint16_t volatile Motor_Status ;                   // ״̬   
extern uint32_t volatile Exec_Counter ;                   // ADCж, ִд   

int16_t static Vbus_Dwon_Limit = (VIN_WORK_MIN_UP+10) ;   // ѹ
int16_t static RpmMechanical_Meas ;                       // еתٵĲֵ  

int16_t static Speed_Adc ;                                // ťADC ͨ˲ֵ
int16_t static RpmMechanical_Set = 0 ;                    // UART յġťADC Ļеתֵ       
int32_t static RPM_Command ;                              // =RpmMechanical_Set Ӧĵת,йʱ=ͣתٶ 
int32_t static RPM_Set_Target ;                           // ĵתĿֵ,Сֵ=0, Ƽٶ
int32_t        RPM_Set = RPM_STOP_VALUE -1 ;              // ִеת,ͣתֵʱ,״̬2дPWM0->MSKEN 

uint32_t static Tick_Voltage_Up ;                         // Դѹֵ"𶯵ѹСֵ"ʱ

int32_t static  Power_Limit = MOTOR_POWER_MAX ;           // 
int32_t static  Err_Power ;                              //  PI õĹ
int32_t static  Kp_Power = 300, Ki_Power = 20;           // ʵתٵ PI 

char      StringRx1[256] ;
char      StringTx1[128] = "\n=0x000";                    // ڴӡַ
char     *pTx1 = StringTx1 ;
int32_t   Rx1_Index = 0 ;                                 // ֽڴ
int32_t   Tx1_Number = 0 ;                                // жϷֽ

 int32_t  Test_Period(void) ;                             // ˳תʱ,תٺͷƵĺ
uint32_t  BinToHex_Str(uint32_t Number, char*pStr) ;
uint32_t  BinToDec_Str(uint32_t Number, char*pStr) ;
uint32_t  Tx0FillFiFo(char*pStr, uint32_t Cnt) ;          // ӡ,дͻͷ, ַܻûȥ
void      ADC00_IRQHandler(void) ;

// M451LC3AE: LQFP48, 39GPIO,ֵDOUT,䷽MODE,书MFP, GPIOȷֵ,м쳣 
void GPIO_Init(void)                           
{  
  //============================== PA0~3 == 4GPIO =========================================================
  PA->DOUT      = 0xFFF0 ;                        
  PA->MODE      = (GPIO_MODE_OUTPUT << 0*2)               // PA0  LED0
                | (GPIO_MODE_OUTPUT << 2*2) ;             // PA2 Ƽ̵,0ر
  SYS->GPA_MFPL = SYS_GPA_MFPL_PA1MFP_PWM1_CH4 
                | SYS_GPA_MFPL_PA3MFP_PWM1_CH2 ;          // PA1,PA3 PWM10                 
  SYS->GPA_MFPH = 0 ;                           
                                                      
  //======================================= PB0~7 == 8GPIO =============================================== 
  PB->DOUT      = 0xFFFF ;                                
  PB->MODE      = 0 ;        
  PB->DINOFF    = 0xFFFF0000 ;                            // 
  SYS->GPB_MFPL = SYS_GPB_MFPL_PB0MFP_DAC                 // SYS_GPB_MFPL_PB0MFP_EADC_CH0             
                | SYS_GPB_MFPL_PB1MFP_EADC_CH1 
                | SYS_GPB_MFPL_PB2MFP_EADC_CH2            // 8 · ADC 
                | SYS_GPB_MFPL_PB3MFP_EADC_CH3 
                | SYS_GPB_MFPL_PB4MFP_EADC_CH4             
//                | SYS_GPB_MFPL_PB4MFP_ACMP0_N           // ACMP ڲοѹ
                | SYS_GPB_MFPL_PB5MFP_ACMP0_P2            // ӲBrake 
                | SYS_GPB_MFPL_PB6MFP_EADC_CH14 
                | SYS_GPB_MFPL_PB7MFP_EADC_CH15 ;                           
  SYS->GPB_MFPH = 0 ;    
                                                        
  //=========================================== PC0~7 == 8GPIO =========================================== 
  PC->DOUT      = ShutDown_AllMOS ; 
  PC->MODE      = 0x4F555 ;                               // PWM0·  SDK M453PC9 ˸LED
  SYS->GPC_MFPL = SYS_GPC_MFPL_PC0MFP_PWM0_CH0 
                | SYS_GPC_MFPL_PC1MFP_PWM0_CH1 
                | SYS_GPC_MFPL_PC2MFP_PWM0_CH2
                | SYS_GPC_MFPL_PC3MFP_PWM0_CH3 
                | SYS_GPC_MFPL_PC4MFP_PWM0_CH4
                | SYS_GPC_MFPL_PC5MFP_PWM0_CH5 ;      
  SYS->GPC_MFPH = 0 ;
                                                       
  //============================================ PD0~3,PD7 == 5GPIO ======================================
  PD->DOUT      = 0xFFFF ;                                
  PD->MODE      = (GPIO_MODE_QUASI  << (2*2))             // PD2, brake ʹ             
                | (GPIO_MODE_OUTPUT << (7*2)) ;           // ACMP0_O 
  PD->DINOFF    = 0x00010000 ;                            //  PD0_EADC6 
  SYS->GPD_MFPL = (1ul << SYS_GPD_MFPL_PD0MFP_Pos)        // EADC6M45xC M45xD PD0 ADC 
                | SYS_GPD_MFPL_PD7MFP_ACMP0_O    
                | SYS_GPD_MFPL_PD2MFP_PWM0_BRAKE0 ;       // PD2 Brake ,
  SYS->GPD_MFPH = 0 ;                                     
                                                     
  //============================================PE0,PE8~13 == 7GPIO ======================================
  PE->DOUT      = 0xFFFF ;                                // PE10 1   
  PE->MODE      = (GPIO_MODE_QUASI  <<  (0*2))
                | (GPIO_MODE_OUTPUT << (10*2))
                | (GPIO_MODE_QUASI  << (11*2)) 
                | (GPIO_MODE_QUASI  << (12*2)) 
                | (GPIO_MODE_QUASI  << (13*2)) ;                           
  SYS->GPE_MFPL = 0 ;   
  SYS->GPE_MFPH = SYS_GPE_MFPH_PE8MFP_UART1_TXD 
                | SYS_GPE_MFPH_PE9MFP_UART1_RXD ;      
                                                      
  //============================================= PF0~6 == 7GPIO ========================================= 
  PF->DOUT      = 0xFFFF ;                                
  PF->MODE      = 0 ;                                
  SYS->GPF_MFPL = 0x01100000 ;                            // PF34_HXT, PF56_ICE, PF56 SWD ӿڹ                                                

//  PE->DBEN    = 0x3800 ;                                // PE11,12,13 ʹȥ
//  GPIO->DBCTL = 0x0009 ;                                // 512HCLKȥʱ (512/72 = 7us)
//  PE->INTTYPE = 0 ;                                     // ж
//  PE->INTSRC  = ~0 ;
//  PE->INTEN   = 0x38003800 ;                            // PE11,12,13غ½ж
//  NVIC_SetPriority(GPE_IRQn, 2);
//  NVIC_EnableIRQ(GPE_IRQn) ;		

}

//==================================================================================================
//             main()  
//==================================================================================================
int main(void)
{  
  int32_t   temp32, temp32_1 ;
  uint32_t  Last_SysTickRelay, Tick_Short ;  

  Timer1_Init() ;                                         // Timer1, ˺ Delayus() ʱ
  PWM0_Init() ;    
  PWM0_Set_Period(gPWM_Period) ;                          //  PWM  
  Set_PWM_Frequency_LPF(PWM_Frequency, 200);              // FOCƵʺ͵ͨƵ,ȱʡ15295Hz,200
  
//  PWM0->CTL0 |= 0x80000000 ;                            // PWM (дλ), ӵʱPWM                                                       
  
  UART1_Init(9600) ;  
  GPIO_Init() ;                                           // MSKEN=0x3F, PWM ֵ = ShutDown_AllMOS   
                                                           
  Tx0FillFiFo("\n=V23",5) ;   
  temp32 = SYS->RSTSTS & 0xFFFF;                          // λԴĴǵ16λ
  SYS->RSTSTS = 0x01BF ;                                  // , д18λԴ־, λ0
  BinToHex_Str(temp32, &StringTx1[7]) ;                   // ַ,String[4]~[7] 
  Tx0FillFiFo(StringTx1, 8) ;                             // UART ַ

//  // ˴PWM1 PFC , PWM1 ʱ(PLL)PWM0 ʱ(PCLK0)һ, ֵͬ, PWM1 Ƶʿһ
//  PWM1_Init(gPWM_Period) ;                                
//  PWM1->PERIOD[2] = (gPWM_Period*3>>2) -5*72 ;          // ڵ3/4ٶ 5us       
//  PWM1->PERIOD[4] = (gPWM_Period*3>>2) -5*72 ;          // 72ϼʱ2.5us, ¼ 2.5us 
 
  PWM0->SSTRG = PWM_SSTRG_CNTSEN_Msk ;            // ͬ12·PWM(PWM16·),MASK,
                                                          // PWM1 ڶں, ı
//  PWM1->PERIOD[2] = gPWM_Period >>1 ;                   // PWM1ʱѡPLL PWM0 ʱӿһ     
//  PWM1->PERIOD[4] = gPWM_Period >>1 ;                   // PWM1 ڱΪPWM0 һ
//  PWM1->MSKEN = 0 ;                                     // PWM1 ʼ, PFC ʹܿʼͨ
 
////============================================================================================
      // ȫֱʼ, ϵʱȴ, ɷŴ
////============================================================================================

  HCLK_Switch_to_PLL() ;                                  //  PLL ȶ, HCLK ʱл PLL, 
                                                          // ж,ܴж,ʿGPIOжϷں
  Motor_Status     = 0 ;                                      
  Tick_Voltage_Up   = SysTick_Relay ;                     // ¼ϵʱ
  Rotation_Direction = Expect_Direction ;                 // ȡת򿪹ֵ Expect_Direction 

  Stop_Runing = Stop_SWITCH_OFF ;                         // дֵ SysTick жLED ˸
                                   
  DAC->CTL  = DAC_CTL_DACEN_Msk ;                         // ģⲿֵʹܲҪ̫ǰ, ܿϵʱԴʱ  
  DAC->TCTL = 720 ;                                       // תʱ 10us
  
  ACMP01->CTL[0] = ACMP_CTL_POSSEL_P2                     // ѡ P2          
                 | ACMP_CTL_NEGSEL_CRV                    // ѡڲѹ          ѡžȥ 
                 | ACMP_CTL_FILTSEL_16PCLK                // 16PCLK / 72 =0.22us  
                 | ACMP_CTL_OUTSEL_Msk                    // ʹfilter
                 | (2<<8)                                 // λжϱ־IF0,           (1<<8) 
                 | 0x0005 ;                               // ʹܻز,   ʹ ACMP  
  ACMP01->VREF = 2 ;                                      // ѹ 5V *(1/6 + 2/24) = 1.25V
   
  ADC_Init() ;                                            // PWM ADC ж 
  while((int8_t)Status_15V != (int8_t)~0);                // 15V ѹ, , LED һֱ˸
               
////============================================================================================
                                                          // ִе 5V ѹ,PWM Brake,MOS û                              
  PWM0->INTSTS1 = ~0 ;                                    // жϱ־
  PWM0->INTEN1 = 0x0707 ;                                 // 07ʹܵƽBrakeж,07ʹܱж
  SYS_LockReg(0) ;  
                                                   
//==========================================================================================
//   MOS ֱͨ᲻ᱨ·, Ҳͬʱֱͨͨĺôǿɼ쵽ĸMOS ·

  //RPM_Set = RPM_STOP_VALUE -1 ;                         // ͣתֵС, PWM0->MSKEN д(ʼֵ,ʡ)

  //Exec_Counter = 20;    Motor_Status = 2;                                         
  //PWM0->MSKEN  = 0x3D ;                                 // bit1=0, A  MOS ͨ 50% 
  //while(Motor_Status) ;                                 
  //if(FlagBrake & Flagb_SHUT_MOS) Tx0FillFiFo("\n A Up-Mos fail",15) ;                     
  //  
  //Exec_Counter = 20;    Motor_Status = 2;               // ״̬0˳ж,ѹرйʹPWM0->MSKEN=0x3F 
  //PWM0->MSKEN  = 0x37 ;                                               // bit3=0, B  MOS ͨ 50% 
  //while(Motor_Status) ;                   
  //if(FlagBrake & Flagb_SHUT_MOS) Tx0FillFiFo("\n B Up-Mos fail",15) ;                     

  //Exec_Counter = 20;    Motor_Status = 2;  
  //PWM0->MSKEN  = 0x1F ;                                 // bit5=0, C  MOS ͨ 50% 
  //while(Motor_Status) ;                    
  //if(FlagBrake & Flagb_SHUT_MOS) Tx0FillFiFo("\n C Up-Mos fail",15) ;                     
   
  Exec_Counter = PWM_10th_sec ;    Motor_Status = 2;      // 0.1 , ״̬2 ռձ 50%, 
  PWM0->MSKEN  = 0x15;                                    // =1λر(MOS),=0λͨ(MOS)Ծٵݳ
  while(Motor_Status) ;                                   // ״̬2ִص״̬0,ADCжѹرйʹ                                        
 
  while(FlagBrake & Flagb_SHUT_MOS){                      // MOS л,ȫ,SysTickжLED ֿ
    Delayus(1000*1000) ;
    Tx0FillFiFo("\nUp Mos fail",12) ;                     // һӡһ
  } 
  
  Exec_Counter = 50 ;                                     // ʱ,=0״̬¶·0ADCֵ
  while(Exec_Counter) ;                                   // ADC жϸһ˳Ͷ ADC ֵ
  
  Zero_Current_ADC0 = (uint16_t)EADC->DAT[0] ;            
  Zero_Current_ADC1 = (uint16_t)EADC->DAT[1] ;            //  SCTL  , ADC ͨ  
  Zero_Current_ADC2 = (uint16_t)EADC->DAT[2] ;
  
  //== ӼZero_Current_ADC00ֵƫ 2048 ̫(10%)Ϊй ============

  Exec_Counter = 20 ;    Motor_Status = 2;                // ״̬2  50% ռձ
  PWM0->MSKEN  = 0x2A;                                    // MOS (=1λ)ر,  MOS ͨ
  while(Motor_Status) ;                                   // ״̬2 ִص״̬0,жѹMOS 
  Exec_Counter = 10 ;                                     // ״̬0ִ10, ܱ״̬
  
  while(FlagBrake & Flagb_SHUT_MOS){                      // ⵽·,MOS л,SysTickжLED ֿ
    Delayus(1000*1000) ;
    Tx0FillFiFo("\nDown Mos fail",14) ;                   // һӡһ, ӡ    
  } 
 
  SYS->GPF_MFPL = 0 ;                                     // SWDGPIOԺ,,ICPʱ	

//  GPE_IRQHandler();                                     // HallAngleȡóֵ, ޸пƲҪ
//==============================================================================================
// ʽ: V-Ri = LPi+e; 1ADCֵ=M,i=Mi,ʱADCֵٳH, ʽҲӷĸٳ1000000MH
// V-Ri=(1000000LPMHi+e*1000000MH)/(1000M*40*25H); ΢L',ADCֵHֵi'=MHi,ʽΪ
// (40V-40Ri)=(L'Pi' + e')/(1000M*25H); ĸøUnit_Magnify =1000M*25H, e' = *Unit_Magnify*40 
// Ϲʽ, ѹʱ0.1Vٳ4ֵ,  㷴ƳUnit_Magnify = *40, 25mVֵ

// LI32λ,15λ, 17λ =131072uH,ֵٴ,оͳ10, Unit_MagnifyҲ10 

#if 1  
  Lq_Inductor  = 690 ;                                    //  uH,  
  Ld_Inductor  = 665 ;                                    //  Lq >= Ld
  Unit_Magnify = CURRENT_Adc1000*25*8 ;                   // H=8, ʾADC ֵ8ڽǶȹ
  
#else
  Lq_Inductor  = 690 >>3;                                 // LqIq29λ: 0x1FFF_FFFF           
  Ld_Inductor  = 665 >>3;                                 // ̫LqIq(32λ),8    
  Unit_Magnify = CURRENT_Adc1000*25 ;                     // H=8 8 
  
#endif                                            //ADC12λ,815λ, Lq32.768mHͿԳ2,4,8

  Stop_Runing = Stop_POWER_LOW;                           // ϵдǷѹ,ADC ѹ
  
  // ѭ,1>,ǷǷѹµȸֲת,  Stop_Runing
  //          2>,жǷͣת
  //          3>, PI, 趨תٱ: RPM_Command, RPM_Set_Target  RPM_Set
   
  while(1){              

  ////====  Power ѹ,Stop_Runing еǷѹ־ ====== 15V ѹжADC ж ======================
    if(Vbus_0v1 >= Vbus_Dwon_Limit){                             // м̵, ʱҪӳ  
      if((Tick_Voltage_Up - SysTick_Relay) >= 5){ RELAY_ON();    // 220V,ѹʱ0.5~1 ̵
        if((Tick_Voltage_Up - SysTick_Relay) >= 10){             // ̵Լ100ms, Լʱת
          Vbus_Dwon_Limit = VIN_WORK_MIN ;                       

          Stop_Runing &= ~Stop_POWER_LOW ;                       // ѹ־
        } 
      }
           
      if(Vbus_0v1 > VIN_WORK_MAX) Stop_Runing |= Stop_POWER_TOO_HIGH ;    // ѹ
      else Stop_Runing &= ~Stop_POWER_TOO_HIGH ;                          // ˴ûӻز      
      
    }
    else{  Tick_Voltage_Up = SysTick_Relay ;                     // ֻеѹʱ,Ų,ڼ̵ʱ
      Vbus_Dwon_Limit = VIN_WORK_MIN_UP ;                       
     
                               // һЩ־, 0ĳЩ                                       
      Active_FailCount = 0 ;                                                  
      Stop_Runing &= ~(Stop_ACTIVE_FAIL | Stop_PHASE_OPEN) ;     // ȡȱͶʧܱ־
      
      if((Motor_Status + Exec_Counter) == 0 ) RELAY_OFF();       // ѹһ;ȥ״̬0ͣת,ʹܹرպؼ̵       
      Stop_Runing |= Stop_POWER_LOW ;                            // λѹ־, ǰ             
    }                                                          
                                                                 
    ////==== ADC жǷ⵽ 15V ̫, ADC ж15VһϹعʹ ================================
  
    if(FlagBrake & Flagb_SHUT_MOS) Stop_Runing |= Stop_SHORT ;   // ·,ͣת־ 
    else Tick_Short = SysTick_Relay ;                            // ·,ʱֵٸ
              
    if(Status_15V == (int16_t)~0) Stop_Runing &= ~Stop_15V_LOW;  // IPM Fo 16PWM 
    
  ////==== ȡť ADC ֵ,  UART жջеת趨ֵ, Ӧĵתֵ RPM_Command ==========    
    temp32    = ((uint16_t)EADC->DAT[3]) ;                            
    Speed_Adc = (temp32 + Speed_Adc*31 +16) >>5 ;          // ȶ, ADC ֵ+15/-16仯ʱ, Speed_Adc                                
    temp32 = Speed_Adc ;

    RpmMechanical_Set = temp32 ;                // ťUARTĻеת,עʹ˾ʱʵʱֵת                           
    
    temp32 = RpmMechanical_Set * POLE_PAIR ;                     // ת
    if(Rotation_Direction != Expect_Direction) temp32 = 0;       // 趨תʵתһ, ͣת
    else if( Stop_Runing ) temp32 = 0 ;                          // "ͣת־"0, ͣת                                                                      
    else if(temp32 < 0)  temp32 = 0 ;                
    else if(temp32 > RPM_SET_MAX) temp32 = RPM_SET_MAX ;           

    RPM_Command = temp32 ;                                       // 0 ~ RPM_SET_MAX,ֵ=0ʱת趨ֵ
    if(Stop_Runing & 0x00FF){ RPM_Set_Target=0;  RPM_Set = RPM_STOP_VALUE;            // ת趨ֵд0
      if(Stop_Runing & 0x000F){ Exec_Counter = 1*PWM_10th_sec;  Motor_Status = 0;  }  // ¸PWM ڹعʹ      
    }
             
    ////==== ADCж, еPI , ͻȻסͣתп ADC ֵ =================================
    if(Motor_Status >= 3){
      temp32 = (CURRENT_Max_f12 >>4) * 5 >> 5 ;                  // 12λС7(5λС)ٳ5/4 = *5>>9
      if(Is_Meas_LPF_f5 > temp32){                             
        Exec_Counter = 20*PWM_10th_sec;                          // ʹ2(ɹؼms˳)
        Motor_Status = 0;                                        
      }
    }

////====  RPM_Set ֵҪת,Ҫͣת ========================================================== 
    
// ֻExec_Counter =0 ʱ޸Motor_Status Ƿֹĳ״̬δPWMжִйֱΪ״̬
// ״̬0: 6·ʹ(Ƶ) 
// ״̬1: 0ѹʹʹܣʽ߶ʽɲ, ִнȥ״̬0
// ״̬2: 0ѹ,   RPM_Set < RPM_STOP_VALUE дPWM0->MSKEN, ждMSKEN ·ʹʹ 
//                     RPM_Set >=RPM_STOP_VALUE  MOS ʹ, ߶ʽSVPWM ڸԾٵݳ 
//        ״̬2 ִRPM_Set <RPM_STOP_VALUE ȥ״̬0,  RPM_Set >0 ȥת, ȥ״̬ MOTOR_STOP_STATUS

// ״̬3,4: ϶ת,ͬ Motor_Status |=0x10; ״̬Ϊ0x130x14               
// ״̬5: ʱ䵽,RPM_Set>0 ȥ״̬4ת,򱣳״̬5
// ״̬6: ˳תʱλ, Ȼ״̬4ת   
// ״̬0x13, 0x14: ͬ״̬, תٵ͵۲ʱ Motor_Status &= ~0x30, ʧ״̬3  4  
  ////====ת RPM_Command,  RPM_Set_Target ʱ, Ƽٶ ======================== 
    
    //=========================== ͬת ======================================    
    if((Motor_Status & 0x10) == 0x10){                    
      if((RPM_Set<=0) &&((RPM_Measure*65536/60/PWM_Frequency) <(PULL_Ommega_Min_f16 >>16))){ // תٵ
        Exec_Counter = 3*PWM_10th_sec ;                                                              
        Motor_Status = 1 ;                                 // ȥ״̬1 ɲ, ׼ٴ    
        
        if(Stop_Runing & Stop_POWER_LOW){                  // ѹͣת                                                               
                                                                                   
        }
            // ԭ, ӡ Stop_Runing   
      }
    }    
    //===================== δͬ(ͣתת), 趨ת RPM_Set С0, Ҫת =====================
    else if(RPM_Set <= 0){                 
      if(Motor_Status >= 3){                             // 3,4,5,6,7    
          
        if(Motor_Status == 5 ){
          Rotation_Direction = Expect_Direction;         // ״̬5ʱ,ת, RPM_Set ͣתֵ
        }
        else if(Motor_Status != 7){                      // ״̬7ɶ, Debug ʱ                        
          Exec_Counter = 5*PWM_10th_sec;                               
          Motor_Status = 1;                              // ״̬3,4,6ȥ״̬1 ɲ,ת
        }   
                                              
      }
      else{                                              // ״̬ <= 2, ͣתɲ״̬                        
        Rotation_Direction = Expect_Direction ;              
        if(Motor_Status == 0){   
          if(FlagBrake & Flagb_SHUT_MOS){                             // IPM  fail , ˶·    
            if((Brake_No_Resume ==0)||(Stop_Runing & Stop_15V_LOW)){  // "·"15VͶǶ·           
              FlagBrake = 0 ;  
              Brake_No_Resume =0 ;                       // 15V ѹǶ·ʱ, 0
              temp32 = SYS_UnlockReg();
                if(SYS->SRAM_STATUS) SYS->IPRST0 = 1;    // RAM , λ
                PWM0->MSKEN   = 0x3F;                    // ǰհMotor_ Statusд0ûعʹ                                                           
                PWM0->INTSTS1 = ~0 ;                     // Brake־,¸PWM,PWMʹ                       
                PWM0->INTEN1  = 0x0707 ;                 // ٴʹ Brake ж
              SYS_LockReg(temp32);    
              Stop_Runing &= ~Stop_SHORT ;   
            }               			
            
            if((Tick_Short - SysTick_Relay) > 5000){         // ·5(ȫͣת),ǵڼμ·
              if(Active_FailCount == 0){ ++Active_FailCount;  
                Brake_No_Resume = 0;                         // ڶټ·,Ͳ 
              }
            }
          }
          // ״̬0 		
          
        }                    
        // ͣת״̬  		
        
      }                                                           
    }
    //========================= δͬ,趨ת RPM_Set 0,  Ҫת ===============
    else{                                                // ״̬2,3,4,5,6ת,ֻ״̬0Զ״̬         
      if(Stop_Runing + Motor_Status + Exec_Counter ==0){            
        
      #if 1
        temp32 = Test_Period();                          // ˳ת,˺ Angle_q =-16384 ʱ̷ת 
        
      #else                                                     
        temp32=0;  Vout_UpLimit_f17=0;                   // ˮ˳ת,ִTest_Period()ת
        
      #endif                                                     
        
        Vout_UpLimit_f17 = Vout_UpLimit_f17*323 >> 12;   // 11ѹ (ADC/4096*5)*11*10=550/4096=0.1V ֵ        
                                                         // ߵѹ 550*0.577 =323 ѹ     
        if(temp32 >0){                                   // ÷ Vout_UpLimit_f17 Сж˳ת׼ȷ  
          Pull_Ommega_f16 = temp32;             
          Motor_Status = 6 ;                             // ˿ܽ״̬00ѹ,ʲֵVq_out_f17
        }
        else if(Vout_UpLimit_f17 < (VIN_WORK_MIN >>1)){  // С,ֹת
          Exec_Counter = PWM_10th_sec >>1;               // Ծٵݳ100/2=50ms 
          Motor_Status = 2 ;                             // ADCж, ɲ״̬35ת 
        }                                                         
        else if(Vout_UpLimit_f17 < VIN_WORK_MIN){        // ת,ɲ   
          Exec_Counter = 10*PWM_10th_sec;  
          Motor_Status = 1;                               
        }
        else{     }                                     // תܿ,ɲΣʹ,Ͳֱɲ 
      }      
    }   
         
    if((Last_SysTickRelay - SysTick_Relay) >= 25){               //  PI 
      Last_SysTickRelay = SysTick_Relay ;                        //  Systick жݼ 
                        
      //== Ȱʵת,  RPM_Set_Target ǰڴ, ӿťӦ  =====================================
      temp32   = RPM_Command ;     
      temp32_1 = RPM_Set_Target ;
      if(temp32 > RPM_SET_MIN) temp32 = RPM_SET_MIN ;              
      if(temp32_1 < temp32) temp32_1 = temp32 ;                  // RPM_Set_Target0޼=ťֵ<=
      
      temp32 = RPM_Command ;  
      if(Motor_Status & 0x10){                                   // ջת, 趨תȸʵת
        if(temp32 > temp32_1){                                   // 趨ת
          if(temp32 < RPM_Measure)        temp32_1 =temp32 ;     // RPM_Set_Target < RPM_Command < RPM_Measure      
          else if(temp32_1 < RPM_Measure) temp32_1 =RPM_Measure; // RPM_Set_Target < RPM_Measure < RPM_Command 
        }          
        else if(temp32 < temp32_1){                              // 趨תټС
          if(temp32 > RPM_Measure)        temp32_1 =temp32 ;     // RPM_Set_Target > RPM_Command > RPM_Measure
          else if(temp32_1 > RPM_Measure) temp32_1 =RPM_Measure; // RPM_Set_Target > RPM_Measure > RPM_Command
        }        
      }
      else{
        if(temp32_1 > RPM_SET_MIN) temp32_1 = RPM_SET_MIN ;      // δͬʱ, 趨תֵֻ
      }
      RPM_Set_Target = temp32_1 ;                                // ʵתٱȽϺ, RPM_Set_Target Ѹ
      
      //==  PI תٰťתٿ,ȡ߽Сֵ,ӵ RPM_ Set_Target ======================
                                           
      temp32 = Power_Limit - Motor_Power ;                      
      temp32_1 = Kp_Power*(temp32 - Err_Power) + Ki_Power*temp32 ;  // PI , ת  
      temp32_1 >>= 8 ;                                              // PI ת, ȥ 8 λС
       
      temp32 =  RPM_Command - RPM_Set_Target ;                      // ť                     
      if(temp32 < -100) temp32 = -100 ;                             // ƽ                                                           
      else{ 
        if(RPM_Measure < RPM_SET_MIN*2){
          if(temp32 > 40) temp32 = 40 ;                             // ʱļٶȿԿһ
        }
        else if(temp32 > 20) temp32 = 20 ;                          // ٶ̫,ʻϳ(ƽϳ) 
      }                                                               
                 //== ťtemp32, PI  temp32_1,ȡ߽Сļӵ RPM_Set_Target ===================
                                              // ʲ, PI , ǰܿƽ
      if(temp32 > temp32_1) temp32 = temp32_1 ;     
      
      temp32 += RPM_Set_Target ;
      if(temp32 > RPM_SET_MAX) temp32 = RPM_SET_MAX ;           
      else if(temp32 < 0) temp32 = 0 ;                
      RPM_Set_Target = temp32 ;                                    // 仯ֵ 0 ~ RPM_SET_MAX
      
      //===  RPM_Set_Target ز,ٸֵ RPM_Set, ֹתת仯, ͣתʱ=ֵ =============
      
      if(temp32 < RPM_SET_MIN){
        if(RPM_Set <= 0){                                           // δתʱ, ֵ 3/4 ת
          if(temp32 <(RPM_SET_MIN*3 >>2)) temp32 =RPM_STOP_VALUE;        
          else temp32 = RPM_SET_MIN ;
        } 
        else if(temp32 <(RPM_SET_MIN >>1))temp32 =RPM_STOP_VALUE;   // תʱСֵ 1/2 ͣת  
        else temp32 = RPM_SET_MIN;                                
      }                                                                                                                      
                    
      RPM_Set = temp32 ;                          // ֵΧ: RPM_SET_MIN ~ RPM_SET_MAX  =RPM_STOP_VALUE
           
      ////====  ============================================================================
         
      RpmMechanical_Meas = (RPM_Measure + (POLE_PAIR>>1)) / POLE_PAIR ;       // еתٲֵ,ʾ 
      
      //temp32 = (int16_t)EADC->DAT[17] ;                          // оƬ¶,0ʱ748mV,¶ϵ -1.672mv/ 
      //Chip_Temperature = 447 - 2*temp32*ADC_VREF_MV/13697;              
      
    #if  0                                                                    // ת,ԷЧ              
      {  uint32_t static TCount ;
        if(RPM_Command <= 0) TCount = 0;                                      // תתһ 
        else if((Motor_Status & 0x10)&&(RPM_Measure > RPM_Command*15 >>4)){
          if(++TCount > 120){ TCount =0;  Expect_Direction ^= 3; }            // 趨תٺ3ת
        }         
      }        
    #endif 
      
    }
    
//    if(Motor_Status == 0){                              // ڲ 
//      EADC->SWTRG |= 0x400 ;                            //  ADC 
//      while(EADC->SWTRG & 0x400);                               
//      DAC->DAT = EADC->DAT[10] ;                        // DAC ʾADC 
//    }    
  
  }   // End of while(1)        
}

//==================================================================================================
//    Cnt εѹڻThreshold,  ˳תλ
//==================================================================================================
int32_t  Emf_ADC_Min ;
uint32_t  Wait_Level(int16_t Level, int16_t Threshold, int16_t Cnt)
{                                                         
   int16_t        temp16 ;
  uint32_t        Tim = TIMER1->CNT, Tim2 = Tim, Flag = 0; 
  uint32_t        Time_OV = 100*1000 ;                    // 100ms ʱ
   int16_t static emf_Adc_Data = 0 ; 
  
  if(Level) Time_OV >>=1 ;                                // ȸߵƽʱ,ʱ(͵ƽʱ)
  do{   
    Delayus(2);                                           
    EADC->SWTRG |= 0x400 ;                                 // 10ģⷴ
    while(EADC->SWTRG & 0x400) ; 
    temp16 = EADC->DAT[10] ;               
    emf_Adc_Data = (emf_Adc_Data + temp16) >> 1 ;         // DAC->DAT =emf_Adc_Data;   // DAC ʾƲ
    if(Emf_ADC_Min > emf_Adc_Data) Emf_ADC_Min = emf_Adc_Data ;  
    if(Vout_UpLimit_f17 < emf_Adc_Data) Vout_UpLimit_f17 = emf_Adc_Data ;   

    if(Level){                                            // ȴѹ Threshold
      if(temp16 > Threshold){ if(++Flag >= Cnt) break;  }  
      else{ Flag = 0;  Tim2 = TIMER1->CNT; }              // ݱ仯֮ǰʱ
    }
    else{                                                 // ȴѹ Threshold
      if(temp16 < Threshold){ if(++Flag >= Cnt) break;  }    
      else{ Flag = 0;  Tim2 = TIMER1->CNT; }              // ۵ȼ, Tim2 ǵƽʱ
    }
  }while(((TIMER1->CNT -Tim)&0xFFFFFF) < Time_OV);              
  return (Flag <<24) +Tim2 ;                              // λ0Ǽ⵽ƽ
}

//== δת0,תظ,תתٸֵ Pull_Ommega_f16,
int32_t Test_Period(void)                                 // ת, Angle_q = -16384 ʱ̷
{                 
  int32_t temp32 = 0, Reverse = 0, temp32_1, temp32_2 ;   // ܲ෴,ȽֵеǷת      
                                                          
  Vout_UpLimit_f17 = 0;     Emf_ADC_Min = 4095;       
  Wait_Level(1,9000,5);                                   // Ʋô, ǳ 50ms ѹ                                      
  temp32_2 = Vout_UpLimit_f17 - Emf_ADC_Min  ;            // СֵĲ   
  if(temp32_2 < 82*2) return 0;                           // С82*2*5/4096 =0.2 V ƽû
                                                          
  Wait_Level(0,-200,5);                                   // Ʋô, 100ms ѹ 
                                                                           // 150ms⵽͵ƽĸ             
  temp32_2 = Vout_UpLimit_f17 - Emf_ADC_Min  ;            // СֵĲ 
  temp32_2 = Emf_ADC_Min +(temp32_2*7 >>4);               // һԵһ,  Angle_q = -16384 ʱ              
  temp32_1 = Wait_Level(0,temp32_2-41,5);                 // 41*5/4096 =0.05V     
  if((temp32_1 >>24) ==0) return 0;                           
  
  temp32_1 = Wait_Level(1, temp32_2+15, 3) ;              // λ0ʱ,  -90 ʱ
  if(temp32_1 >>24){             //  LED_LIGHT_0() ;      // ָʾһ  
       
                     //  B ෴             // ֻһѹ, ޷жת   
    if( 0  /* Vb >Va */) Reverse = 7 ;                    // ˿B෴ƸA, ACBת
    
    if(Wait_Level(0, temp32_2-15, 3)>>24){                // 
      temp32 = Wait_Level(1, temp32_2+15, 3) ;            // ڶȷϴٵ,Ӧ      
      if(temp32 >>24){               //      LED_DARK_1();  
        temp32 = (temp32 - temp32_1)&0xFFFFFF ;           // ⵽ֵ us
        temp32 = 2048000000ul/temp32 ;                    //65536/(temp32/1000000)¾䲹5
        temp32_1 = 0;        
        if(temp32  <  0x0003FFFF ) temp32_1 = 8;          //  8+5 λ
        else if(temp32 <0x007FFFFF) temp32_1 = 3;         //  3+5 λ
        temp32 =((temp32 <<(temp32_1+5))/PWM_Frequency) <<(16-temp32_1);  // Ʒּڷ  
        if(Reverse) temp32 = -temp32 ;                                    // ACB ת,ظֵ
        
//        if(Rotation_Direction) temp32 = -temp32 ;       // ָACBת,ֻA෴ȥ˾
      }
      else temp32 = 0 ;                                   //  ûת,0
    }  
  }   
  return temp32 ;                                         // ֵ0ǲ⵽ֵ, ֵǷת
}

//// ѷFiFo /////////////////////////////////////////////////////////////////////
// β :  *pStr, ַָ
//          Cnt , ַ
//  :   ʣַ
uint32_t Tx0FillFiFo(char*pStr, uint32_t Cnt)
{
  while(Cnt){                                                      
    if(UART1->FIFOSTS & UART_FIFOSTS_TXFULL_Msk ) break ;  // FiFo, ˳ѭ      
    UART1->DAT = *pStr++ ;      --Cnt ;                                                                           
  }
  return  Cnt ;                                          
}
////convert a integer into a string for printing /////////////////////////////////////////
//input : Number, 32bit integer
//       *pStr,  Ÿλַĵַ, ÿһλ, ַ1    
//return: Sum of character converted.
const uint8_t Asc[16]="0123456789ABCDEF" ;
uint32_t BinToDec_Str(uint32_t Number, char*pStr)
{
  uint32_t temp32u, Cnt = 0 ;

  do{
    temp32u = Number ; 
    Number /= 10 ; 
    *pStr-- = Asc[temp32u - Number*10];                    // =0ʱ,һ0
    ++Cnt ;
  }while(Number);                                          // =0ת, *pStr ǰַԭֵ(00x30)
  return Cnt ;
}

uint32_t BinToHex_Str(uint32_t Number, char*pStr)
{
  uint32_t temp32u, Cnt = 0 ;

  do{
    temp32u = Number ; 
    Number >>= 4 ; 
    *pStr-- = Asc[temp32u - (Number <<4)] ;               // =0ʱ,һ0
    ++Cnt ;
  }while(Number);
  return Cnt ;
}

////==== UART1 жϴ , UART1 ѡŽ϶ =============================================================
void UART1_IRQHandler(void)
{
  int32_t temp32 ;
  int8_t  Str ;
  
  if(UART1->INTSTS & (UART_INTSTS_RDAINT_Msk | UART_INTSTS_RXTOINT_Msk)){   // жԴ: յ,ճʱ
    while((UART1->FIFOSTS & UART_FIFOSTS_RXEMPTY_Msk) == 0){            // ջǿ
      Str    = UART1->DAT ;                                             // ݣݻᷴж
      temp32 = (Rx1_Index +1) & 0xFF ;
      if(1 /* temp32 !=  */){ StringRx1[Rx1_Index] = Str ;      // 
        Rx1_Index = temp32 ;                                            // ָһַ
      }
    }    
  }
    
  if(UART1->INTSTS & UART_INTSTS_THREINT_Msk){                          // жԴ: ͻ    
    while(Tx1_Number){                                                  // ݴ        
      if(UART1->FIFOSTS & UART_FIFOSTS_TXFULL_Msk ) break ;             // FiFo ,˳ѭ     
      
      UART1->DAT = *pTx1++ ;                                            // һֽ  
      --Tx1_Number ;      
    }
    
    if(Tx1_Number == 0) UART1->INTEN &= ~UART_INTEN_THREIEN_Msk ;       // ݷ,طж,򷴸ж   
  } 
}         // жֻҪ׼,дTx1_Number  UART1->INTEN |= UART_INTEN_THREIEN_Msk ; ͻжϷ
